(function () {
  window.addEventListener("load", init);

  let activeRace = null;

  function init() {
    


  }

  /**
   * PART A (5pts): 
   * 
   * @param {number} index a unique index for the car being placed.
   * @param {string} color what color this car is
   * @param {string} driver name of the driver
   * @param {number} speed how fast this car goes
   */
  function placeCar(index, color, driver, speed) { 
















  }

  /**
   * 
   */
  function moveCars() {
    
    











  }

  


  /**
   * 
   * @param {Element} car 
   * @returns {boolean} whether or not the car actually moved.
   */
  function moveCar(car) {
    let containerWidth = parseInt(getComputedStyle(id("tracker")).width);
    let carWidth = parseInt(getComputedStyle(qs(".wagon")).width);

    let percentToMove = window.sessionStorage.getItem(car.id) / 100;

    let oldLeftPx = parseInt(getComputedStyle(car).left);
    let newLeftPx = oldLeftPx + (containerWidth * percentToMove);

    let finished = false;
    if ((newLeftPx + carWidth) < containerWidth) {
      car.style.left = newLeftPx + "px";
      finished = true;
    } else {
      car.style.left = (containerWidth - carWidth) + "px";
    }

    return finished;
  }
  
  function boostCar() {
    moveCar(this);
  }

  function newRace() {
    let numWagons = 'num_wagons=' + id('num_wagons').value;
    let distance = 'distance=' + id('distance').value;

    fetch('/new_race?' + numWagons + '&' + distance)
      .then(checkStatus)
      .then(resp => resp.json())
      .then(startRace)
      .catch(err => updateFormFailure(err, "newrace"));
  }

  function addCar() {
    let params = new FormData();
    params.append("capacity", id("wagon_capacity").value);
    params.append("color", id("wagon_color").value);
    params.append("max_speed", id("wagon_max_speed").value);

    fetch("/add_wagon", { method: "POST", body: params })
      .then(checkStatus)
      .then(resp => resp.text())
      .then(resp => updateFormSuccess("newcar"))
      .catch(err => updateFormFailure(err, "newcar"));
  }

  function addDriver() {
    let params = new FormData();
    params.append("name", id("driver_name").value);
    params.append("max_speed", id("driver_max_speed").value);

    fetch("/add_driver", { method: "POST", body: params })
      .then(checkStatus)
      .then(resp => resp.text())
      .then(resp => updateFormSuccess("newdriver"))
      .catch(err => updateFormFailure(err, "newdriver"));
  }

  function startRace(data) {
    updateFormSuccess("newrace");

    let wagons = data["wagons"];
    let drivers = data["drivers"];
    let speeds = data["speeds"];

    for (let i = 0; i < wagons.length; i++) {
      placeCar(i, wagons[i]["color"], drivers[i], speeds[i]);
    }

    activeRace = setInterval(moveCars, 500);

    appendToTable(data);
  }

  function updateStats() {
    console.log("update stats");
  }

  function appendToTable(data) {
    let statsTable = id("stats").getElementsByTagName('tbody')[0];
    
    let newRow = statsTable.insertRow();

    let idCell = newRow.insertCell(0);
    let driversCell = newRow.insertCell(1);
    let wagonsCell = newRow.insertCell(2);

    newRow.insertCell(3);
    newRow.insertCell(4);
    newRow.insertCell(5);

    let wagonColors = [];
    for (let i = 0; i < data['wagons'].length; i++) {
      wagonColors.push(data['wagons'][i]['color']);
    }

    idCell.appendChild(document.createTextNode(data['race_id']));
    driversCell.appendChild(document.createTextNode(data['drivers']));
    wagonsCell.appendChild(document.createTextNode(wagonColors));
  }

  function updateFormSuccess(formId) {
    let form = id(formId);
    
    updateForm(form, "success");

    let inputs = form.querySelectorAll("input");
    for (let i = 0; i < inputs.length; i++) {
      inputs[i].value = '';
    }
  }

  function updateFormFailure(error, formId) {
    console.error(error);
    updateForm(id(formId), "fail");
  }

  function updateForm(form, type) {
    let q;
    if (type === "fail") {
      q = ".red_x";
    } else if (type === "success") {
      q = ".green_check";
    } else {
      return;
    }

    let check = form.querySelector(q);
    check.classList.toggle("hidden");

    setTimeout(() => check.classList.toggle("hidden"), 5000);
  }

  function checkStatus(response) {
    if (!response.ok) {
      throw Error("Error in request: " + response.statusText);
    }
    return response; // a Response object
  }

  /**
   * Returns the element that has the ID attribute with the specified value.
   * @param {string} idName - element ID
   * @returns {object} DOM object associated with id.
   */
  function id(idName) {
    return document.getElementById(idName);
  }

  /**
   * Returns the first element that matches the given CSS selector.
   * @param {string} selector - CSS query selector.
   * @returns {object} The first DOM object matching the query.
   */
  function qs(selector) {
    return document.querySelector(selector);
  }

  /**
   * Returns the array of elements that match the given CSS selector.
   * @param {string} selector - CSS query selector
   * @returns {object[]} array of DOM objects matching the query.
   */
  function qsa(selector) {
    return document.querySelectorAll(selector);
  }

  /**
   * Returns a new element with the given tag name.
   * @param {string} tagName - HTML tag name for new DOM element.
   * @returns {object} New DOM object for given HTML tag.
   */
  function gen(tagName) {
    return document.createElement(tagName);
  }
})();